# A React plugin example for Wordpress

On Wordpress 5.5.1

![Screenshot](https://code.electrolab.fr/fabrice/wordpress-react-plugin-example/-/raw/master/page-screenshot.png)

## How to integrate the plugin in Wordpress

* Install the plugin directory in *wordpress/wp-content/plugins/*
* Check the plugin is listed in http://localhost/wordpress/wp-admin/plugins.php and activate it
* Create a new page and add a **shortcode** block containing `[example-react-app]` or in the code editor
  ```
  <!-- wp:shortcode -->
  [example-react-app]
  <!-- /wp:shortcode -->
  ```

## How to Build the application

* It requires Node JS
* Install NPM packages using the command `npm install`, it must create a *node_module* directory
* Build using the command `npm start`

**Build Output:**

```
> react-example@1.0.0 start /home/www/wordpress-5.5.1/wp-content/plugins/react-example
> wp-scripts start


webpack is watching the files…

Live Reload listening on port 35729

Hash: 2b07918b34348ac47a07
Version: webpack 4.44.2
Time: 5014ms
Built at: 24/10/2020 14:57:11
          Asset       Size  Chunks                   Chunk Names
index.asset.php  122 bytes   index  [emitted]        index
      index.css  316 bytes   index  [emitted]        index
  index.css.map  550 bytes   index  [emitted] [dev]  index
       index.js   17.5 KiB   index  [emitted]        index
   index.js.map   14.4 KiB   index  [emitted] [dev]  index
Entrypoint index = index.css index.js index.css.map index.js.map index.asset.php
[./src/App.scss] 39 bytes {index} [built]
[./src/index.js] 3.51 KiB {index} [built]
[@wordpress/element] external {"this":["wp","element"]} 42 bytes {index} [built]
    + 11 hidden modules
```

It must create a *build* directory containing an *index.js* file.

It runs the [wp-script](https://developer.wordpress.org/block-editor/packages/packages-scripts/) tool.

## References

Some references found on the web, but not checked, could be wrong or outdated ...

* https://vincentdubroeucq.com/utiliser-react-theme-extension-wordpress — Utiliser React dans un thème ou une extension WordPress
* https://ansalbrain.medium.com/wordpress-plugin-development-building-with-react-and-webpack-10f06cae231f — WordPress Plugin Development: Building With React And Webpack
* https://ghostinspector.com/blog/develop-wordpress-plugin-with-webpack-and-react/ — Develop a WordPress Plugin Using Webpack and React
* https://snipcart.com/blog/reactjs-wordpress-rest-api-example — How to Use WordPress with React to Build a Modern Web App
* https://wp-and-react.com — Using ReactJS with WordPress - Tutorials

* https://github.com/gopangolin/wp-reactivate — React boilerplate for WordPress plugins

* https://frontity.org — The React framework for WordPress
